with Vectors;
with Ada.Text_IO; use Ada.Text_IO;
with Ada.Calendar; use Ada.Calendar;

procedure Main is
   package V is new Vectors (Natural, Integer);
   use V;

   Vec : aliased Vector := Empty_Vector & 1 & 2 & 3 & 4;
   T   : Time;
   Sum : Long_Long_Integer;
begin

   Put_Line ("Inserting elements into Vector ..");

   for I in 1 .. 1_000_0000 loop
      Vec.Append (I);
   end loop;

   Put_Line ("Iterating on regular vector ..");
   T := Clock;
   Sum := 0;

   for El of Vec loop
      El := El + 1;
      Sum := Sum + Long_Long_Integer (El);
   end loop;

   Put_Line ("SUM : " & Sum'Image);
   Put_Line ("Time = " & Duration'Image (Clock - T));

   Put_Line ("Iterating on stable vector ..");
   T := Clock;
   Sum := 0;

   declare
      S : Stable.Vector (Vec'Access);
   begin
      for El of S loop
         El := El + 1;
         Sum := Sum + Long_Long_Integer (El);
      end loop;
   end;
   Put_Line ("SUM : " & Sum'Image);

   Put_Line ("Time = " & Duration'Image (Clock - T));
end Main;
